WHERE  	ORG	0FC00H
 MESG0	DEFM	'Error Diagnosis :'
 	DEFB	0DH
 	DEFB	00H
 START2	LD	HL,(41A6H)	; DOS ERROR ROUTINE
 	LD	(DZAP),HL	; STORE IT
 	LD	A,(41A8H)
 	LD	(DZAP1),A
 	LD	HL,START	; OUR PROG. BEGINNING
 	LD	(41A7H),HL	; RIG FOR AUTO INVOKE
 	LD	A,0C3H		; JUMP STATEMENT
 	LD	(41A6H),A	; STORE IT
 	LD	HL,(4020H)	; GET CURSOR POS
 	PUSH	HL		; COPY IT INTO
 	POP	DE		; DE FOR USAGE
 	LD	HL,BANNER
 LOOP8	LDI			; MOVE A BYTE
 	LD	A,(HL)		; GET BYTE
 	OR	A		; SET FLAGS
 	JR	NZ,LOOP8	; IF NOT 0, CONTINUE
 	LD	HL,(4020H)	; GET START AGAIN
 	LD	DE,256
 	ADD	HL,DE
 	LD	(4020H),HL	; MOVE CURSOR DOWN
 	LD	A,(54H)		; MODEL 1 OR 3?
 	DEC	A
 	RET	Z		; RETURN IF MODEL 1
 	LD	HL,40E6H	; FIX"LAST BYTE EXECUTED"
 	LD	(BTFIND+2),HL	; REPLACE MODEL 1 SETTING
 	LD	(K11+7),HL	; IN TWO PLACES
 	RET
 START	DI			; DISABLE INTERRUPTS
 	LD	A,C		; GET ERROR TYPE
 	LD	(K1K1+1),A	; STORE IT FOR ERROR EXIT
 	XOR	A		; ZERO A
 	LD	(WONE),A	; ZERO OUT CALLER ROUTINE
 	LD	A,(40AFH)	; TYPE OF VARIABLE USED
 	LD	(TOVU),A	; STORE IT FOR RETURN
 	CALL	01C9H		; CLEAR SCREEN
 	LD	HL,MESG0	; ERROR DIAGNOSIS
 	CALL	28A7H		; PRINT IT
 LTFIND	LD	HL,(40EAH)	; ERROR LINE
 	LD	(TSTR),HL	; STORE FOR PRINTING
 	EX	DE,HL		; PUT IT IN DE
 	CALL	1B2CH		; FIND LINE IN MEMORY
 	JP	NC,NOERR	; NO ERROR/ERL TOO BIG
 	PUSH	BC		; PUT START OF LINE IN HL
 	POP	HL
 	PUSH	HL		; STORE POS
 	LD	HL,(TSTR)	; GET LINE NUMBER
 	CALL	0FAFH		; PRINT LINE NUMBER
 	LD	A,20H		; BLANK AFTER LINE #
 	CALL	33H		; PRINT BLANK
 	POP	HL		; GET LINE POS.
 BTFIND	LD	DE,(40F7H)	; GET ADDR. OF ERROR -1
 	LD	A,(DE)		; GET POINT OF ERROR
 	OR	A		; IF A=0, ERROR AT START
 	CALL	Z,HERE		; OF LINE, SO, MARK IT
 	LD	BC,4		; SKIP LINE #
 	ADD	HL,BC		; AND NEXT LINE POINTER
 	PUSH	HL		; STORE HL
 	INC	DE		; ADDR. OF ERROR NOW
 	PUSH	DE		; STORE IT FOR LOOPB
 LOOPB	POP	DE		; GET ADDR. OF ERROR
 	POP	HL		; GET POS. IN TEXT LINE
 	CALL	1C90H		; ARE WE AT THE ERROR?
 	CALL	Z,HERE		; IF SO, MARK IT.
 	LD	A,(HL)		; GET CHARACTER
 	INC	HL		; BUMP POS IN TEXT LINE
 	PUSH	HL		; STORE IT FOR LATER
 	PUSH	DE		; STORE ADDR. OF ERROR
 	OR	A		; SET FLAGS
 	JP	Z,EOL		; IF A=0, END OF LINE
 	JP	M,TOKEN		; IF BIT 7 SET, A TOKEN
 	CALL	33H		; ELSE PRINT CHARACTER
 	JR	LOOPB		; CONTINUE TILL EOL
 TOKEN	CP	0FBH		; TEST FOR " ' " REM
 	CALL	Z,BACKUP	; BACK UP OVER GARBAGE
 	SUB	127		; FIND POS IN RW TABLE
 	LD	B,A		; PUT POS IN B
 	LD	HL,1650H	; START OF RW TABLE
 LOOPC	LD	A,(HL)		; GET A BYTE
 	OR	A		; SET FLAGS
 	INC	HL		; BUMP POS. IN TABLE
 	JP	P,LOOPC		; JUMP IF NOT START OF RW
 	DJNZ	LOOPC		; KEEP GOING TILL OUR RW
 	AND	127		; CLEAR BIT 7
 	PUSH	HL		; STORE HL
 	CALL	33H		; PRINT CHARACTER
 	POP	HL		; RESTORE HL
 LOOPD	LD	A,(HL)		; GET NEXT BYTE OF RW
 	INC	HL		; BUMP POINTER
 	OR	A		; SET FLAGS
 	JP	M,LOOPB		; DONE WITH TOKEN
 	PUSH	HL		; STORE HL
 	CALL	33H		; PRINT CHARACTER
 	POP	HL		; RESTORE HL
 	JR	LOOPD		; CONTINUE TILL DONE
 HERE	PUSH	AF		; STORE BYTE HERE
 	LD	A,32		; SPACE
 	CALL	33H		; PRINT SPACE
 	LD	A,153		; GRAPHIC MARKER
 	CALL	33H		; PRINT IT
 	LD	A,153		; MARKER AGAIN
 	CALL	33H		; PRINT IT
 	LD	A,153		; YOU KNOW BY NOW
 	CALL	33H		; PRINT IT
 	LD	A,20H		; SPACE
 	CALL	33H		; PRINT IT
 	POP	AF		; RESTORE ORIGINAL BYTE
 	RET			; DONE
 EOL	LD	A,13		; CARRIAGE RETURN
 	CALL	33H		; PRINT LINE
 	LD	A,13		; ANOTHER CR
 	CALL	33H		; PRINT IT
 	POP	HL		; GET RID OF
 	POP	HL		; GARBAGE ON STACK
 	LD	A,(TOVU)
 	LD	(40AFH),A	; RESTORE VARIABLE TYPE
 DEXIT	LD	A,(WONE)	; WHO CALLED THIS?
 	OR	A		; SET FLAGS
 	RET	NZ		; BACK TO CALLER ROUTINE
 	POP	HL		; PULL RETURN OFF STACK
 	LD	A,(409AH)	; GET ERROR CODE
 	LD	E,A		; PUT IT IN E
 	EI
 DZAP	DEFW	0000
 DZAP1	DEFB	00
 	EI
 	CALL	41A9H		; DOS WILL TAKE OVER NOW
 BACKUP	PUSH	HL		; STORE IT
 	PUSH	AF		; STORE IT TOO
 	LD	HL,BUMESG	; BACKUP STRING
 	CALL	28A7H		; PRINT IT
 	POP	AF
 	POP	HL
 	RET
 BUMESG	DEFW	0808H		; BACK SPACES
 	DEFW	0808H
 	DEFW	2008H
 	DEFB	00H		; MESG. TERMINATOR
 NOERR	LD	A,(TOVU)	; RESTORE VARIABLE TYPE
 	LD	(40AFH),A	; DESTROYED BY 27A8H CALL
 K1K1	LD	A,00H		; STORED FOR LATER
 	LD	(409AH),A	; USE ON ERROR EXIT
 	EI
 	JP	DEXIT		; DOS EXIT
 MESGN	DEFM	'No Error Found!'
 	DEFB	0DH
 	DEFB	00H
 MESGD	DEFM	'Data examination reveals last set of data accessed was :'
 	DEFB	0DH
 	DEFB	00H
 TSTR	DEFW	0000H		; TEMP. LINE # STORAGE
 TOVU	DEFB	00H		; TYPE OF VARIABLE USED
 STARTD	DI
 	LD	HL,MESGD
 	LD	A,(40AFH)
 	LD	(TOVU),A
 	LD	A,1
 	LD	(WONE),A
 	CALL	28A7H
 	LD	HL,40FFH	; BYTE AFTER LAST USABLE
 	LD	(BTFIND+2),HL	; DATA READ IN
 	LD	HL,40DAH	; LINE # FOR DATA STMT
 	LD	(LTFIND+1),HL	; STORE IT
 	LD	HL,(40FFH)	; GET POS
 	LD	A,(HL)		; WHAT'S THERE
 	OR	A		; SET FLAGS
 	JR	Z,NODATA	; IF NO DATA, SKIP
 	CALL	LTFIND
 K11	LD	HL,40EAH	; RESTORE OTHER PART
 	LD	(LTFIND+1),HL	; (ERROR FINDER)
 	LD	HL,40F7H
 	LD	(BTFIND+2),HL
 	RET
 NODATA	LD	HL,MESGND	;NO DATA FOUND
 	CALL	28A7H		; PRINT MESSAGE
 	LD	A,(TOVU)	; RESET VARIABLE TYPE
 	LD	(40AFH),A	; TO FIX TM ERROR
 	JR	K11		; RESTORE THINGS CHANGED
 MESGND	DEFM	'No data statement found!'
 	DEFW	000DH
 WONE	DEFB	00H
 DOSCM	DEFM	'BASIC,64512,DEFUSR0=&HFC13:X=USR(0):DEFUSR0=&HFD83'
 	DEFW	000DH
 BANNER	DEFM	'--------- Error Finder   Ver. 2.2   By Mike Brotherton -------------------------------- X = USR(0) to trace data '
 	DEFM	'---------------'
 	DEFB	00
 START1	LD	HL,DOSCM
 	JP	4405H		; DOS COMMAND/DEAD END
 	END	START1		; BASIC AUTOMATICALLY!
